// SplitCmdLine.cpp: CSplitCmdLine NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SplitCmdLine.h"
#include "MainAr.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CSplitCmdLine::CSplitCmdLine()
{
	m_argc = 1;
	m_argv = NULL;
	m_lpCmdLine = NULL;
	m_lpBaseDirectory = NULL;
	m_bHide = FALSE;
}

CSplitCmdLine::~CSplitCmdLine()
{
	if (m_lpCmdLine)
		free(m_lpCmdLine);
	if (m_argv)
		free(m_argv);
}

BOOL CSplitCmdLine::Split(const char* lpCmdLine)
{
	// R}hC
	if (lpCmdLine)
		m_lpCmdLine = _strdup(lpCmdLine);
	else
		m_lpCmdLine = _strdup("");
	char* p = m_lpCmdLine;
	while (*p)
	{
		++m_argc;
		if (*p == '\"')
		{
			*p = '\0';
			++p;
			while (*p != '\"' && *p)
				++p;
			if (*p == NULL)
				return FALSE;
			*p = '\0';
			++p;
			if (*p == NULL)
				break;
			if (*p != ' ')
				return FALSE;
			while (*p == ' ')
			{
				*p = '\0';
				++p;
			}
		}
		else
		{
			++p;
			while (*p != ' ' && *p)
				++p;
			if (*p == NULL)
				break;
			while (*p == ' ')
			{
				*p = '\0';
				++p;
			}
		}
	}
	
	// R}hC蓖
	m_argv = (char**)malloc((m_argc + 1) * sizeof(char*));
	p = m_lpCmdLine;
	m_argv[0] = DLL_NAME;
	for (int i = 1; i < m_argc; ++i)
	{
		while (*p == NULL)
			++p;
		if (!_stricmp(p, "-hide") || !_stricmp(p, "/hide"))
		{
			// \[h
			m_bHide = TRUE;
			--m_argc;
			--i;
		}
		else if (IsBaseDir(p))
		{
			// fBNgݒ
			m_lpBaseDirectory = p;
			--m_argc;
			--i;
		}
		else
			m_argv[i] = p;
		while (*p)
			++p;
	}
	m_argv[i] = "";

	if (*m_argv[1] == 'l' || *m_argv[1] == 't')
	{
		m_bHide = TRUE;
	}
	return TRUE;
}

// fBNg
BOOL CSplitCmdLine::IsBaseDir(const char* lpOption)
{
	if (*lpOption == '-' || *lpOption == '/')
		return FALSE;

	const char* p = lpOption + strlen(lpOption) - 1;
	if (*p == '\\' &&  _ismbstrail((PBYTE)lpOption, (PBYTE)p) == 0)
		return TRUE;

	return FALSE;
}
